%define anolis_release 2
%global base_version 1.59

Name:           perl-threads-shared
Version:        1.64
Release:        %{anolis_release}%{?dist}
Summary:        Perl extension for sharing data structures between threads
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/threads-shared
Source0:        https://cpan.metacpan.org/authors/id/J/JD/JDHEDDEN/threads-shared-%{base_version}.tar.gz
Patch0:         threads-shared-1.59-Upgrade-to-1.60.patch
Patch1:         threads-shared-1.60-threads-shared-fix-leak.patch
Patch2:         threads-shared-1.59-Upgrade-to-1.61.patch
Patch3:         threads-shared-1.61-Upgrade-to-1.62.patch
Patch4:         threads-shared-1.62-Upgrade-to-1.64.patch
BuildRequires:  findutils gcc make
BuildRequires:  perl-devel perl-generators perl-interpreter
BuildRequires:  perl(Config) perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Spec) perl(strict) perl(warnings)
BuildRequires:  perl(Carp) perl(Scalar::Util) perl(threads) >= 1.73
BuildRequires:  perl(XSLoader) perl(ExtUtils::testlib) perl(File::Path)
BuildRequires:  perl(Test::More) perl(POSIX) perl(Time::HiRes)

Requires:       perl(Carp) perl(threads) >= 1.73 perl(XSLoader)

%description
By default, variables are private to each thread, and each newly created
thread gets a private copy of each existing variable. This module allows
you to share variables across different threads (and pseudo-forks on
Win32). It is used together with the threads module.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n threads-shared-%{base_version}

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1 OPTIMIZE="$RPM_OPT_FLAGS"
%{make_build}

%install
%{make_install}
find $RPM_BUILD_ROOT -type f -name '*.bs' -size 0 -delete
%{_fixperms} $RPM_BUILD_ROOT/*

%check
unset GIT_DIR PERL_BUILD_PACKAGING PERL_CORE PERL_RUNPERL_DEBUG \
    RUN_MAINTAINER_TESTS
make test

%files
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/threads*
%{_mandir}/man3/*

%files doc
%doc Changes examples README

%changelog
* Fri Apr 14 2023 Kaihao Bai <carlo.bai@linux.alibaba.com> - 1.64-2
- optimize spec

* Wed Feb 08 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.64-1
- remove versioned MODULE_COMPAT_ requires
- update to version 1.64

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.59-2
- rebuild with perl 5.36.0

* Wed Mar 09 2022 liuzhilin <liuzhilin@uniontech.com> - 1.59-1
- Init for Anolis OS 23
